// --------------
// Author: Wicked
// --------------

new GuiControl(BlocklandPlusGUIManager) {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "1024 768";
	minExtent = "8 2";
	enabled = "1";
	visible = "1";
	clipToParent = "1";

	new GuiWindowCtrl(BlocklandPlusGUIManagerWindow) {
		profile = "GuiWindowProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "250 210";
		extent = "500 350";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		command = "canvas.popdialog(BlocklandPlusGUIManager);";
		accelerator = "escape";
		text = "Blockland Plus GUI Manager";
		maxLength = "255";
		resizeWidth = "0";
		resizeHeight = "0";
		canMove = "1";
		canClose = "1";
		canMinimize = "0";
		canMaximize = "0";
		minSize = "50 50";
		closeCommand = "canvas.popdialog(BlocklandPlusGUIManager);";

		new GuiSwatchCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "12 30";
			extent = "52 30";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			color = "80 80 80 255";

			new GuiMLTextCtrl() {
				profile = "GuiMLTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "2 1";
				extent = "48 28";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				lineSpacing = "2";
				allowColorChars = "0";
				maxChars = "-1";
				text = "<just:center><color:f8f8ff>User\nApproved";
				maxBitmapHeight = "-1";
				selectable = "0";
				autoResize = "1";
			};
		};
		new GuiSwatchCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "65 30";
			extent = "52 30";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			color = "80 80 80 255";

			new GuiMLTextCtrl() {
				profile = "GuiMLTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "2 1";
				extent = "48 28";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				lineSpacing = "2";
				allowColorChars = "0";
				maxChars = "-1";
				text = "<just:center><color:f8f8ff>System\nApproved";
				maxBitmapHeight = "-1";
				selectable = "0";
				autoResize = "1";
			};
		};
		new GuiSwatchCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "118 30";
			extent = "152 30";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			color = "80 80 80 255";

			new GuiMLTextCtrl() {
				profile = "GuiMLTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "2 8";
				extent = "148 14";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				lineSpacing = "2";
				allowColorChars = "0";
				maxChars = "-1";
				text = "<just:center><color:f8f8ff>Information";
				maxBitmapHeight = "-1";
				selectable = "0";
				autoResize = "1";
			};
		};
		new GuiSwatchCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "271 30";
			extent = "206 30";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			color = "80 80 80 255";

			new GuiMLTextCtrl() {
				profile = "GuiMLTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "2 8";
				extent = "202 14";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				lineSpacing = "2";
				allowColorChars = "0";
				maxChars = "-1";
				text = "<just:center><color:f8f8ff>Options";
				maxBitmapHeight = "-1";
				selectable = "0";
				autoResize = "1";
			};
		};
		new GuiBitmapButtonCtrl() {
			profile = "BlockButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "329 3";
			extent = "90 19";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			command = "BlocklandPlusOpenPrefs();";
			text = "Preferences";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "base/client/ui/button1";
			lockAspectRatio = "0";
			alignLeft = "0";
			alignTop = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
		new GuiSwatchCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "11 62";
			extent = "470 248";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			color = "255 255 255 192";
		};
		new GuiScrollCtrl() {
			profile = "ColorScrollProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 61";
			extent = "480 250";
			minExtent = "200 200";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			willFirstRespond = "1";
			hScrollBar = "alwaysOff";
			vScrollBar = "alwaysOn";
			constantThumbHeight = "0";
			childMargin = "0 0";
			rowHeight = "10";
			columnWidth = "30";

			new GuiSwatchCtrl(BlocklandPlusGUIManagerList) {
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "470 250";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				color = "0 0 0 0";
			};
		};
		new GuiBitmapButtonCtrl() {
			profile = "BlockButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "220 320";
			extent = "60 20";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			command = "BlocklandPlusSaveGUIChanges();";
			text = "Save";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "base/client/ui/button1";
			lockAspectRatio = "0";
			alignLeft = "0";
			alignTop = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
	};
};

function BlocklandPlusGUIManagerWindow::onWake(%gui)
{
	BlocklandPlusEditPos(%gui);
}
function BlocklandPlusOpenGUIManager()
{
	%num = 0;
	for(%x = 1; %x <= $BlocklandPlus::Client::GUICount; %x++)
	{
		if(isObject(getWord($BlocklandPlus::Client::GUI[%x], 1)))
		{
			%num++;
			getWord($BlocklandPlus::Client::GUI[%x], 1).delete();
		}
	}
	$BlocklandPlus::Client::GUICount -= %num;
	%stream = new fileObject();
	%stream.openForRead("config/BLP/BlocklandPlusGUIList.txt");
	while(!%stream.isEOF())
	{
		$BlocklandPlus::Client::GUICount++;
		%line = %stream.readLine();
		%name = getWord(%line, 0);
		%sysapp = getWord(%line, 1);
		if(%sysapp == 0)
			%sysapp = "./Icons/Unapproved";
		if(%sysapp == 1)
			%sysapp = "./Icons/Approved";
		$BlocklandPlus::Client::GUIApproved[%name] = getWord(%line, 2);
		
		%version = "";
		%version2 = "";
		%author = "";
		%author2 = "";
		%desc = "";
		%desc2 = "";
		discoverfile("config/BLP/" @ %name @ "/Client.zip");
		discoverfile("config/BLP/" @ %name @ "/DB.zip");
		%stream2 = new fileObject();
		if(isFile("config/BLP/" @ %name @ "/Client/Info.txt"))
		{
			%stream2.openForRead("config/BLP/" @ %name @ "/Client/Info.txt");
			for(%x = 0; %x < 4; %x++)
			{
				%line = %stream2.readLine();
				if(getWord(%line, 0) $= "Version:")
					%version = "(Client)" @ %line;
				else if(getWord(%line, 0) $= "Author:")
					%author = "(Client)" @ %line;
				else if(getWord(%line, 0) $= "Description:")
					%desc = "(Client)" @ %line;
			}
			%stream2.close();
		}
		if(isFile("config/BLP/" @ %name @ "/DB/Info.txt"))
		{
			%stream2.openForRead("config/BLP/" @ %name @ "/DB/Info.txt");
			for(%x = 0; %x < 4; %x++)
			{
				%line = %stream2.readLine();
				if(getWord(%line, 0) $= "Version:")
					%version2 = "(Datablock)" @ %line;
				else if(getWord(%line, 0) $= "Author:")
					%author2 = "(Datablock)" @ %line;
				else if(getWord(%line, 0) $= "Description:")
					%desc2 = "(Datablock)" @ %line;
			}
			%stream2.close();
		}
		%stream2.delete();
		%infotext = trim(%version TAB %author TAB %desc TAB %version2 TAB %author2 TAB %desc2);
		%infotext = strreplace(%infotext, "		", "	");
		
		%mod = "BlocklandPlusBox" @ %name;
		if(isObject(%mod))
		{
			$BlocklandPlus::Client::GUICount--;
			%mod.delete();
		}
		%modbox = new GuiSwatchCtrl(%mod)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "2 " @ 36 * ($BlocklandPlus::Client::GUICount - 1) + 2;
			extent = "468 34";
			minExtent = "8 2";
			visible = "1";
			color = "205 205 205 255";

			new GuiSwatchCtrl()
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "1 1";
				extent = "50 32";
				minExtent = "1 1";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				color = "150 150 150 255";

				new GuiCheckBoxCtrl()
				{
					profile = "GuiCheckBoxProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "18 7";
					extent = "14 20";
					minExtent = "8 8";
					enabled = "1";
					visible = "1";
					clipToParent = "1";
					variable = "$BlocklandPlus::Client::GUIApproved" @ %name;
					groupNum = "-1";
					buttonType = "ToggleButton";
				};
			};
			new GuiSwatchCtrl()
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "54 1";
				extent = "50 32";
				minExtent = "1 1";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				color = "150 150 150 255";

				new GuiBitmapCtrl()
				{
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "9 1";
					extent = "32 32";
					minExtent = "8 2";
					visible = "1";
					bitmap = %sysapp;
					wrap = "0";
					lockAspectRatio = "0";
					alignLeft = "0";
					overflowImage = "0";
					keepCached = "0";
				};
			};
			new GuiButtonCtrl()
			{
				profile = "BlockButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "107 1";
				extent = "150 32";
				minExtent = "8 2";
				command = "BlocklandPlusFileText(\"" @ %name @ "\",\"" @ %version TAB %author TAB %desc TAB %version2 TAB %author2 TAB %desc2 @ "\",1);";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				text = %name;
				groupNum = "-1";
				buttonType = "PushButton";
				bitmap = "base/client/ui/button1";
				lockAspectRatio = "0";
				alignLeft = "0";
				alignTop = "0";
				overflowImage = "0";
				mKeepCached = "0";
				mColor = "255 255 255 255";
			};
			new GuiButtonCtrl()
			{
				profile = "BlockButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "260 1";
				extent = "68 32";
				minExtent = "8 2";
				command = "BlocklandPlusGUIManagerLoad(" @ %name @ ");";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				text = "Load";
				groupNum = "-1";
				buttonType = "PushButton";
				bitmap = "base/client/ui/button1";
				lockAspectRatio = "0";
				alignLeft = "0";
				alignTop = "0";
				overflowImage = "0";
				mKeepCached = "0";
				mColor = "255 255 255 255";
			};
			new GuiButtonCtrl()
			{
				profile = "BlockButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "328 1";
				extent = "68 32";
				minExtent = "8 2";
				command = "BlocklandPlusGUIManagerScan(" @ %name @ ");";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				text = "Scan";
				groupNum = "-1";
				buttonType = "PushButton";
				bitmap = "base/client/ui/button1";
				lockAspectRatio = "0";
				alignLeft = "0";
				alignTop = "0";
				overflowImage = "0";
				mKeepCached = "0";
				mColor = "255 255 255 255";
			};
			new GuiButtonCtrl()
			{
				profile = "BlockButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "396 1";
				extent = "68 32";
				minExtent = "8 2";
				command = "BlocklandPlusGUIManagerDeleteVerify(" @ %name @ ");";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				text = "Delete";
				groupNum = "-1";
				buttonType = "PushButton";
				bitmap = "base/client/ui/button1";
				lockAspectRatio = "0";
				alignLeft = "0";
				alignTop = "0";
				overflowImage = "0";
				mKeepCached = "0";
				mColor = "255 255 255 255";
			};
		};
		$BlocklandPlus::Client::GUI[$BlocklandPlus::Client::GUICount] = %name SPC %modbox;
		BlocklandPlusGUIManagerList.extent = getWord(BlocklandPlusGUIManagerList.extent, 0) SPC 36 * $BlocklandPlus::Client::GUICount + 2;
		BlocklandPlusGUIManagerList.add(%modbox);
	}
	%stream.close();
	%stream.delete();
	canvas.pushdialog(BlocklandPlusGUIManager);
}
function BlocklandPlusSaveGUIChanges()
{
	for(%x = 1; %x <= $BlocklandPlus::Client::GUICount; %x++)
		BlocklandPlusUpdateGUIList(getWord($BlocklandPlus::Client::GUI[%x], 0), "keep", $BlocklandPlus::Client::GUIApproved[getWord($BlocklandPlus::Client::GUI[%x], 0)]);
	canvas.popdialog(BlocklandPlusGUIManager);
}
function BlocklandPlusGUIManagerLoad(%name)
{
	BlocklandPlusSaveGUIChanges();
	BlocklandPlusOpenGUIManager();
	%approveds = BlocklandPlusCheckApprovedFile(%name);
	%sysapproved = getWord(%approveds, 0);
	%approved = getWord(%approveds, 1);
	if(!%sysapproved)
		MessageBoxYesNo("Accept Unapproved File Load Request?", "You are about to load an unapproved file(config/BLP/" @ %name @ "). This file could contain malicious code, and it is advised not to load it. Do you want to load the file anyway?", "BlocklandPlusLoadFile(\"" @ %name @ "\",1);", "return;");
	else if(!%approved)
		MessageBoxYesNo("Accept Unapproved File Load Request?", "You are about to load an unapproved file(config/BLP/" @ %name @ "). Do you want to load the file anyway?", "BlocklandPlusLoadFile(\"" @ %name @ "\",1);", "return;");
	else if($BlocklandPlus::Client::AskBeforeExec)
		MessageBoxYesNo("Accept Load Request?", "You are about to load file(config/BLP/" @ %name @ "). Do you want to load the file?", "BlocklandPlusLoadFile(\"" @ %name @ "\",1);", "return;");
	else
		BlocklandPlusLoadFile(%name, 1);
}
function BlocklandPlusGUIManagerScan(%name)
{
	BlocklandPlusSaveGUIChanges();
	BlocklandPlusOpenGUIManager();
	BlocklandPlusCheckFile(%name, 2);
}
function BlocklandPlusGUIManagerDeleteVerify(%name)
{
	BlocklandPlusSaveGUIChanges();
	BlocklandPlusOpenGUIManager();
	MessageBoxYesNo("Warning!", "This file will be permanently deleted with no recovery option. Are you sure you want to delete it?", "BlocklandPlusGUIManagerDelete(\"" @ %name @ "\");", "return;");
}
function BlocklandPlusGUIManagerDelete(%name)
{
	discoverfile("config/BLP/" @ %name @ "/Client.zip");
	discoverfile("config/BLP/" @ %name @ "/DB.zip");
	discoverfile("config/BLP/" @ %name @ "/Prefs.cs");
	
	%tempfile = "config/BLP/" @ %name @ "/Client.zip";
	if(isFile(%tempfile))
		fileDelete(%tempfile);
	%tempfile = "config/BLP/" @ %name @ "/DB.zip";
	if(isFile(%tempfile))
		fileDelete(%tempfile);
	%tempfile = "config/BLP/" @ %name @ "/Prefs.cs";
	if(isFile(%tempfile))
		fileDelete(%tempfile);
	
	BlocklandPlusUpdateGUIList(%name, 2, 2);
	canvas.popdialog(BlocklandPlusGUIManager);
	BlocklandPlusOpenGUIManager();
	messageBoxOk("File Deleted", "The file has been deleted. You will need to restart Blockland if this file has already loaded to fully remove its contents.");
}
function BlocklandPlusOpenPrefs()
{
	BlocklandPlusOpenPreferences();
}