// --------------
// Author: Wicked
// --------------

new GuiControl(BlocklandPlusPreferences) {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "800 600";
	minExtent = "8 2";
	enabled = "1";
	visible = "1";
	
	new GuiWindowCtrl(BlocklandPlusPreferencesWindow) {
		profile = "GuiWindowProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "280 180";
		extent = "300 240";
		minExtent = "8 2";
		visible = "1";
		command = "canvas.popdialog(BlocklandPlusPreferences);";
		accelerator = "escape";
		text = "Blockland Plus Preferences";
		maxLength = "255";
		resizeWidth = "0";
		resizeHeight = "0";
		canMove = "1";
		canClose = "1";
		canMinimize = "0";
		canMaximize = "0";
		minSize = "50 50";
		closeCommand = "canvas.popdialog(BlocklandPlusPreferences);";

		new GuiSwatchCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "11 31";
			extent = "279 159";
			minExtent = "8 2";
			visible = "1";
			color = "255 255 255 255";
		};
		new GuiScrollCtrl() {
			profile = "ColorScrollProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 30";
			extent = "280 160";
			minExtent = "160 160";
			visible = "1";
			willFirstRespond = "1";
			hScrollBar = "alwaysOff";
			vScrollBar = "alwaysOn";
			constantThumbHeight = "0";
			childMargin = "0 0";
			rowHeight = "10";
			columnWidth = "30";

			new GuiSwatchCtrl(BlocklandPlusPreferencesList) {
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "270 160";
				minExtent = "8 2";
				visible = "1";
				color = "0 0 0 0";
				
				new GuiSwatchCtrl()
				{
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "5 5";
					extent = "260 24";
					minExtent = "1 1";
					enabled = "1";
					visible = "1";
					clipToParent = "1";
					color = "150 150 150 255";

					new GuiCheckBoxCtrl()
					{
						profile = "GuiCheckBoxProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "5 2";
						extent = "250 20";
						minExtent = "8 8";
						enabled = "1";
						visible = "1";
						text = "Enable Blockland Plus";
						clipToParent = "1";
						variable = "$BlocklandPlus::Client::BlocklandPlusEnabled";
						groupNum = "-1";
						buttonType = "ToggleButton";
					};
				};
				new GuiSwatchCtrl()
				{
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "5 30";
					extent = "260 24";
					minExtent = "1 1";
					enabled = "1";
					visible = "1";
					clipToParent = "1";
					color = "150 150 150 255";

					new GuiCheckBoxCtrl()
					{
						profile = "GuiCheckBoxProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "5 2";
						extent = "250 20";
						minExtent = "8 8";
						enabled = "1";
						visible = "1";
						text = "Auto Rescan Files With New Version";
						clipToParent = "1";
						variable = "$BlocklandPlus::Client::AutoRescanFilesNV";
						groupNum = "-1";
						buttonType = "ToggleButton";
					};
				};
				new GuiSwatchCtrl()
				{
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "5 55";
					extent = "260 24";
					minExtent = "1 1";
					enabled = "1";
					visible = "1";
					clipToParent = "1";
					color = "150 150 150 255";

					new GuiCheckBoxCtrl()
					{
						profile = "GuiCheckBoxProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "5 2";
						extent = "250 20";
						minExtent = "8 8";
						enabled = "1";
						visible = "1";
						text = "Ask Me Before Downloading A File";
						clipToParent = "1";
						variable = "$BlocklandPlus::Client::AskBeforeDownload";
						groupNum = "-1";
						buttonType = "ToggleButton";
					};
				};
				new GuiSwatchCtrl()
				{
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "5 80";
					extent = "260 24";
					minExtent = "1 1";
					enabled = "1";
					visible = "1";
					clipToParent = "1";
					color = "150 150 150 255";

					new GuiCheckBoxCtrl()
					{
						profile = "GuiCheckBoxProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "5 2";
						extent = "250 20";
						minExtent = "8 8";
						enabled = "1";
						visible = "1";
						text = "Ask Me Before Loading A File";
						clipToParent = "1";
						variable = "$BlocklandPlus::Client::AskBeforeExec";
						groupNum = "-1";
						buttonType = "ToggleButton";
					};
				};
				new GuiSwatchCtrl()
				{
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "5 105";
					extent = "260 24";
					minExtent = "1 1";
					enabled = "1";
					visible = "1";
					clipToParent = "1";
					color = "150 150 150 255";

					new GuiCheckBoxCtrl()
					{
						profile = "GuiCheckBoxProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "5 2";
						extent = "250 20";
						minExtent = "8 8";
						enabled = "1";
						visible = "1";
						text = "Delete Files With Syntax Errors";
						clipToParent = "1";
						variable = "$BlocklandPlus::Client::DeleteSyntaxErrorFiles";
						groupNum = "-1";
						buttonType = "ToggleButton";
					};
				};
				new GuiSwatchCtrl()
				{
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "5 130";
					extent = "260 24";
					minExtent = "1 1";
					enabled = "1";
					visible = "1";
					clipToParent = "1";
					color = "150 150 150 255";

					new GuiCheckBoxCtrl()
					{
						profile = "GuiCheckBoxProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "5 2";
						extent = "250 20";
						minExtent = "8 8";
						enabled = "1";
						visible = "1";
						text = "Delete Files That Crash Blockland";
						clipToParent = "1";
						variable = "$BlocklandPlus::Client::DeleteCrashingFiles";
						groupNum = "-1";
						buttonType = "ToggleButton";
					};
				};
			};
		};
		new GuiBitmapButtonCtrl() {
			profile = "BlockButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "120 200";
			extent = "60 30";
			minExtent = "8 2";
			visible = "1";
			command = "BlocklandPlusSavePreferenceChanges();";
			text = "Save";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "base/client/ui/button1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
	};
};

function BlocklandPlusPreferencesWindow::onWake(%gui)
{
	BlocklandPlusEditPos(%gui);
}
function BlocklandPlusOpenPreferences()
{
	canvas.pushdialog(BlocklandPlusPreferences);
}
function BlocklandPlusSavePreferenceChanges()
{
	BlocklandPlusCreatePrefs(2);
	canvas.popdialog(BlocklandPlusPreferences);
}